/************************************************************************
 * Programa    : mceitor 0.9.2 			         		*
 * Archivo     : mceitor.h  						*
 * 									*
 * Autor : Boris Estudiez						*
 * Nick  : slice							*
 * Fecha : 09/11/2001 							*
 * Mails : 43824@electronica.frc.utn.edu.ar - boris@flashmail.com 	*
 *	 								*
 * Licenced Under GNU							*
 *	 								*
 * Powered by C!							*
 ************************************************************************/


/* CTES. */
#define MC_VERSION "Mceitor 0.9.2 (BETA)"
#define EXIT_TERM_ERR 10

/* Funciones de Secciones */
void det_seccion(void);
void se_seccion(void);
void inv_seccion(void);
void redm_seccion(void);
void redm_manual_seccion(void);
void help_seccion(void);
void mceitor_seccion(void);

/* Funciones auxiliares */
void finish(int n);
int check_frac(char *frac);
int check_num(char *num);
double frac2num(char *frac);

/*
  No se termino de traducir los mensajes, necesito un traductor.
  Al hacer cambios, corregir declaracion de struct msg en mccurses.c . 
 */
struct msg
{
   char *main_menu[10];
   char *seccion_titles[5];
   char *misc_men[13];
   char *misc_txt[14];
};

/* mensages en castellano */
struct msg msg_es = 
{
   /* mensages de main_menu */
   { 
      " Principal ", 
      "Calcular Determinantes", 
      "Sistemas de Ecuaciones",
      "Invertir Matrices",
      "Reducir Matriz",
      "Reducir Manualmente Matriz",
      "Ayuda",
      "English/Spanish",
      "Acerca de Mceitor",
      "Salir"
   },

   /* mensages de titulos de secciones */
   { 
      "FUNCION DETERMINANTE",
      "SISTEMAS DE ECUACIONES LINEALES",
      "INVERTIR MATRICES",
      "REDUCIR MATRICES",
      "REDUCIR MATRIZ MANUALMENTE"
   },
   
   /* mensages de menues variados */
   {   
      " Esta seguro? ",
      " Datos Correctos? ",
      " Resultado ",
      " Volver a Principal? ",
      " Cambiar/Change? ",
      "Cambiar castellano a ingles/Change spanish to inglish", 
      "Determinante = %g",
      "Sistema Carece de Solucion!",
      "La Matriz no tiene inverza!",
      "[ Si ]",
      "[ No ]",
      "[ Ok ]",
      " Ver Operaciones elementales? "
   },   
   
   /* mensages de textos variados */
   {
      "Dimencion (maximo 12): ",
      "Matriz [%dx%d]",
      "Numero de Incognitas (maximo 11): ",
      "Resultado: Sistema Compatible Determinado.",
      "Resultado: Matriz [%dx%d] Invertida.",
      "Matriz [%dx%d] Reducida por filas.",
      "Filas (max 13): ",
      "Columas (max 12): ",
      "Operaciones Elementales Realizadas (%d)",
      "e1(i, j)    : Intercambiar fila i por fila j.",
      "e2(i, j, k) : Sumar fila j previamente multiplicada por k a fila i.",
      "e3(i, k)    : Multiplicar fila i por k.",
      "Usar ",
      " o presione cualquier tecla para salir."
   }   
}; 
                           

struct msg msg_en = 
{
   /* mensages de main_menu */
   { 
      " Main Menu ",
      "Calculate Determinantes",
      "Equation System's",
      "Invert Matrix",
      "Reduce Matrix",
      "Manual Reduce Matrix",
      "Help",
      "Ingles/Castellano",
      "About Mceitor",
      "Quit"
   },

   /* mensages de titulos de secciones */
   { 
      "FUNCION DETERMINANTE",
      "SISTEMAS DE ECUACIONES LINEALES",
      "INVERTIR MATRICES",
      "REDUCIR MATRICES",
      "REDUCIR MATRIZ MANUALMENTE"
   },
   
   /* mensages de menues variados */
   {  
      " Are You Sure? ",
      " Datos Correctos? ",
      " Resultado ",
      " Return to Main Menu? ",
      " Cambiar/Change? ",
      "Cambiar ingles a castellano/Change inglish to spanish", 
      "Determinante = %g",
      "Sistema Carece de Solucion!",
      "La Matriz no tiene inverza!",
      "[ Yes ]",
      "[ No ]",
      "[ Ok ]",
      " Ver Operaciones elementales? "
   },   
   
   /* mensages de textos variados */
   {
      "Dimencion (maximo 12): ",
      "Matrix [%dx%d]",
      "Numero de Incognitas (maximo 11): ",
      "Resultado: Sistema Compatible Determinado.",
      "Resultado: Matriz [%dx%d] Invertida.",
      "Matriz [%dx%d] Reducida por filas.",
      "Row (max 13): ",
      "Column (max 12): ",
      "Operaciones Elementales Realizadas (%d)",
      "e1(i, j)    : Intercambiar fila i por fila j.",
      "e2(i, j, k) : Sumar fila j previamente multiplicada por k a fila i.",
      "e3(i, k)    : Multiplicar fila i por k.",
      "Usar ",
      " o presione cualquier tecla para salir."
    }   
}; 
                           


