/************************************************************************
 * Programa    : mceitor 0.9.2 			         		*
 * Archivo     : mxlib.h  						*
 * Descripcion : Declaraciones de funciones, estructuras y constantes 	*
 * usadas por mxlib.c 							*
 * 									*
 * Autor : Boris Estudiez						*
 * Nick  : slice							*
 * Fecha : 09/11/2001 							*
 * Mails : 43824@electronica.frc.utn.edu.ar - boris@flashmail.com 	*
 *	 								*
 * Licenced Under GNU							*
 *	 								*
 * Powered by C!							*
 ************************************************************************/


/* Constantes Devueltas Por las Funciones */

#define M_NOSOL	  -5   /* No tiene solucion */
#define M_NOFOUND -1   /* No encontrado */
#define M_ERROR    0   /* Error */
#define M_OK	   1   /* Exito */

/************************************************************************
 *  Dimenciones y puntero de la matriz.					*
 *  Cada matriz creada debe estar dentro de esta estructura.		*
 ************************************************************************/

typedef struct mx{ int row; int col; double **val; } MATRIX; 


/*------------------------Prototipos de funciones---------------------- */

/* Funciones de manejo de matrices */

MATRIX *new_matrix(int row, int col);
void del_matrix(MATRIX *mat);
int colcpy_matrix(MATRIX *mat1, MATRIX *mat2, int col1, int col2);
int cpy_matrix(MATRIX *mat1, MATRIX *mat2);

/* Funciones Algebraicas y Matematicas */

double trimat(MATRIX *mat);
double detm(MATRIX *mat);
double mcomp(MATRIX *mat, int row, int col);
int scandval(MATRIX *mat, int row, int col);
int scanuval(MATRIX *mat, int row, int col);
int scanrval(MATRIX *mat, int row, int col);
int nullups(MATRIX *mat, int current_row);
int sysresolv(MATRIX *mA, MATRIX *mb, MATRIX *m_result);
int cof(MATRIX *mat);
int adj(MATRIX *mat);
int inv(MATRIX *mat);
int trn(MATRIX *mat);
void e1(MATRIX *mat, int row1, int row2);
void e2(MATRIX *mat, int row1, int row2, double  k);
void e3(MATRIX *mat, int row1, double  k);
void redmat(MATRIX *mat, char **op);
void multk(MATRIX *mat, double  k);




