/************************************************************************ 
 * Nombre  : mceitor 0.9.2 			         		*
 * Estado  : Beta							*
 * Archivo : mceitor.c							*
 *  									*
 * Autor   : Boris Estudiez 						*
 * Nick    : slice							*
 * Fecha   : 03/03/2002							*
 * Mails   : boris@flashmail.com - 43824@electronica.frc.utn.edu.ar 	*
 * Web	   : http://geocities.com/slicesoft				*
 *	 								*
 * Licenced Under GNU							*
 *	 								*
 * Requiere : Libreria Matematica (libm) y Libreria NCURSES.		*
 *	 								*
 * Compilacion Bajo Unix's: make					*
 * Ejecucion: ./mceitor 						*
 *	 								*
 *	 								*
 * Powered by C!							*
 *	 								*
 ************************************************************************/

#include <curses.h>
#include <menu.h>
#include <form.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include "include/mxlib.h"
#include "include/mccurses.h"
#include "include/mceitor.h"

/* Variables Globales */
static char buf[BUFSIZ]; /* buffer */
extern struct msg *msg_lan; /* lenguage a usar (declaracion) */
struct msg *msg_lan; /* lenguage a usar (definicion) */
/* presicion minima usada por e2() y e3() de mxlib.c */
extern double MIN_NUMP;  /* (declaracion) */
double MIN_NUMP = 0.0000001; /* (definicion) - MINimo Numero de Presicion */

int main(void)
{	

   WINDOW *wtitle, *wcomment;
   WIZARD_MENU main_menu;
   int x, y;
   char *pitem_name;
   
   msg_lan = &msg_es;
   signal(SIGINT, finish); /* Atrapar Ctrl-C */
   
   initscr(); /* iniciar libreria curses */
   keypad(stdscr, TRUE); /* permitir el mapeo de teclado */
   nl(); /* decir a curses  hacer NL->CR/NL a la salida */
   cbreak(); /* modo crudo (raw), no usar buffer o esperar '\n' */
   noecho(); 

   if(has_colors()){ /* terminal con colores */
      start_color();
     /* Colores disponibles por defecto (8): 
      * COLOR_BLACK
      * COLOR_WHITE
      * COLOR_RED
      * COLOR_BLUE
      * COLOR_GREEN
      * COLOR_CYAN
      * COLOR_MAGENTA
      * COLOR_YELLOW
      *
      * Asignacion de Pares de Colores F=Fore_color B=Back_color 
      * BK = black BE = blue
      */
      init_pair(COLOR_FWBR, COLOR_WHITE, COLOR_RED);
      init_pair(COLOR_FWBBE, COLOR_WHITE, COLOR_BLUE);
      init_pair(COLOR_FCBBE, COLOR_CYAN, COLOR_BLUE);
      init_pair(COLOR_FBKBW, COLOR_BLACK, COLOR_WHITE);
      init_pair(COLOR_FCBW, COLOR_CYAN, COLOR_WHITE);
      init_pair(COLOR_FRBW, COLOR_RED, COLOR_WHITE);
      init_pair(COLOR_FWBBK, COLOR_WHITE, COLOR_BLACK);
      init_pair(COLOR_FRBBK, COLOR_RED, COLOR_BLACK);
      init_pair(COLOR_FGBBK, COLOR_GREEN, COLOR_BLACK);
      init_pair(COLOR_FWBC, COLOR_WHITE, COLOR_CYAN);
      init_pair(COLOR_FRBC, COLOR_RED, COLOR_CYAN);
      init_pair(COLOR_FMBBK, COLOR_MAGENTA, COLOR_BLACK);
      init_pair(COLOR_FYBBK, COLOR_YELLOW, COLOR_BLACK);
      init_pair(COLOR_FCBBK, COLOR_CYAN, COLOR_BLACK);
      init_pair(COLOR_FBEBBK, COLOR_BLUE, COLOR_BLACK);
   }   
         
   bkgd(COLOR_PAIR(COLOR_FWBBK));

   getmaxyx(stdscr, y, x);
   if(y < 24 || x < 80)
      finish(EXIT_TERM_ERR); /* terminal demasiado pequenio */

   /* sub-ventana de titulo */
   wtitle = subwin(stdscr, 1, x, 0, 0);
   wbkgd(wtitle, COLOR_PAIR(COLOR_FBKBW));
   mvwaddstr(wtitle, 0, x/2 - strlen(MC_VERSION)/2, MC_VERSION);   
   
   /* sub-ventana de comentario */
   wcomment = subwin(stdscr, 1, x, y-1, 0);
   wbkgd(wcomment, COLOR_PAIR(COLOR_FWBBE));
   waddstr(wcomment, "Licenced Under GNU - Website: http://geocities.com/slicesoft");
     
   /* Configuracion de main_menu */
   main_menu.win = stdscr;
   main_menu.menu_item_fore = COLOR_PAIR(COLOR_FBKBW);
   main_menu.menu_item_back = COLOR_PAIR(COLOR_FWBR);
   main_menu.menu_win_color = COLOR_PAIR(COLOR_FWBR); 
   main_menu.item_name = (char **) calloc(9, sizeof(char*));
   main_menu.item_name[0] = msg_lan->main_menu[1];
   main_menu.item_name[1] = msg_lan->main_menu[2];
   main_menu.item_name[2] = msg_lan->main_menu[3];
   main_menu.item_name[3] = msg_lan->main_menu[4];
   main_menu.item_name[4] = msg_lan->main_menu[5];
   main_menu.item_name[5] = msg_lan->main_menu[6];
   main_menu.item_name[6] = msg_lan->main_menu[7];
   main_menu.item_name[7] = msg_lan->main_menu[8];
   main_menu.item_name[8] = msg_lan->main_menu[9];
   main_menu.n_items = 9;
   main_menu.menu_title = msg_lan->main_menu[0];
   main_menu.menu_txt = NULL;
   main_menu.menu_mark = " ";
   main_menu.menu_format = "VERTICAL";
   main_menu.menu_item_justify = "CENTER";
   main_menu.pos_y = 5;
   main_menu.pos_x_center = TRUE;
   main_menu.funcion = NULL;

   if(new_wizard_menu(&main_menu) == ERR) /*crear main_menu*/
      finish(EXIT_FAILURE);
   /* Refresco de Pantalla */      
   touchwin(stdscr); /* toda subwin necesita un touchwin al padre antes */
   wnoutrefresh(wtitle);
   wnoutrefresh(stdscr);
   doupdate();   
      

   while(1){
      if((pitem_name = drive_wizard_menu(&main_menu)) == NULL)
         finish(EXIT_FAILURE);
      
      if(strcmp(pitem_name, main_menu.item_name[0]) == 0)
         det_seccion();         
      if(strcmp(pitem_name, main_menu.item_name[1]) == 0)
         se_seccion();         
      if(strcmp(pitem_name, main_menu.item_name[2]) == 0)
         inv_seccion();            
      if(strcmp(pitem_name, main_menu.item_name[3]) == 0)
         redm_seccion();            
      if(strcmp(pitem_name, main_menu.item_name[4]) == 0)
         redm_manual_seccion();            
      if(strcmp(pitem_name, main_menu.item_name[5]) == 0)
         help_seccion();  
      if(strcmp(pitem_name, main_menu.item_name[6]) == 0)
         if(sn_wizard_menu(stdscr, 17, -1, msg_lan->misc_men[4],
         msg_lan->misc_men[5], A_BOLD) == TRUE){ /* cambiar idioma */
              if(msg_lan == &msg_es)
                 msg_lan = &msg_en;
              else
                 msg_lan = &msg_es;                 
              del_wizard_menu(&main_menu);
              main_menu.item_name = (char **) calloc(9, sizeof(char*));
              main_menu.menu_title = msg_lan->main_menu[0];
              main_menu.item_name[0] = msg_lan->main_menu[1];
              main_menu.item_name[1] = msg_lan->main_menu[2];
              main_menu.item_name[2] = msg_lan->main_menu[3];
              main_menu.item_name[3] = msg_lan->main_menu[4];
              main_menu.item_name[4] = msg_lan->main_menu[5];
              main_menu.item_name[5] = msg_lan->main_menu[6];
              main_menu.item_name[6] = msg_lan->main_menu[7];
              main_menu.item_name[7] = msg_lan->main_menu[8];
              main_menu.item_name[8] = msg_lan->main_menu[9];
              new_wizard_menu(&main_menu);
         }     
      if(strcmp(pitem_name, main_menu.item_name[7]) == 0)
         mceitor_seccion();            
      if(strcmp(pitem_name, main_menu.item_name[8]) == 0)
         if(sn_wizard_menu(stdscr, 17, -1, msg_lan->misc_men[0], NULL,0) 
         == TRUE)
            break; 
   }   
    

   del_wizard_menu(&main_menu); /*borrar main_menu*/
   delwin(wtitle);
   delwin(wcomment);
   
   finish(EXIT_SUCCESS);
}

/*-------------------------FUNC. DE SECCIONES-----------------------------*/


/* Seccion para el calculo de determinates */
void det_seccion(void)
{
   WINDOW *det_win;
   MATRIX_FORM det_matrix; /* matriz formulario */
   MATRIX *mA;
   double det;
   int n; /* dimencion */
   int x, y;

   /* Ventana de la seccion de determinates */
   getmaxyx(stdscr, y, x);
   det_win = newwin(y-2, x, 1, 0);
   wbkgd(det_win, COLOR_PAIR(COLOR_FWBBK));
   
   wattron(det_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(det_win, 1, 0, msg_lan->seccion_titles[0]); 
   wattron(det_win, COLOR_PAIR(COLOR_FWBBK));
   do { 
      mvwaddstr(det_win, 3, 0, msg_lan->misc_txt[0]);
      echo();
      wclrtoeol(det_win);
      wgetnstr(det_win, buf, BUFSIZ);
   }while((n = atoi(buf)) <= 0 || n > 12); 
   noecho();
   mvwprintw(det_win, 5, 0, msg_lan->misc_txt[1], n, n); 
   
   /* Configuracion de det_matrix */
   det_matrix.win = det_win;
   det_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
   det_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
   det_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
   det_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
   det_matrix.matrix_edit = TRUE; 
   det_matrix.matrix_style = "NORMAL"; 
   det_matrix.row = n; /* filas */
   det_matrix.col = n; /* columnas */
   det_matrix.field_deep = 5;
   det_matrix.field_space = 1;
   det_matrix.pos_y = 8;
   det_matrix.pos_x = 0;
  
   if(new_matrix_form(&det_matrix) == ERR)
      finish(EXIT_FAILURE);
   
   /* Cargar det_matrix */
   while(1){  
      load_matrix_form(&det_matrix);
      if(sn_wizard_menu(det_win, 11, -1, msg_lan->misc_men[1],NULL,0) == TRUE)
         break;
      redraw_matrix_form(&det_matrix);   
   }    
   redraw_matrix_form(&det_matrix);   
  
   if((mA = new_matrix(n, n)) == NULL) /* crear matriz  */
      finish(EXIT_FAILURE);
  
   matf2mat(mA, &det_matrix);
   
   det = detm(mA);
   sprintf(buf, msg_lan->misc_men[6], det);
   ok_wizard_menu(det_win, 10, -1, msg_lan->misc_men[2], buf, A_BOLD); 
   
   del_matrix_form(&det_matrix);
   del_matrix(mA);
   
   wclear(det_win);
   wnoutrefresh(det_win);
   doupdate();
   delwin(det_win);
}

/* Seccion para resolver sistemas de ecuaciones lineales */
void se_seccion(void)
{
   WINDOW *se_win;
   MATRIX_FORM se_matrix; /* Matriz form. del sistema de ecuaciones */
   MATRIX_FORM res_matrix; /* Matriz form. de resultados */
   MATRIX *mA, *mb, *mx; /* inv(mA) * mb = mx */
   int n; /* numero de incognitas */
   int x, y;
   
   /* Ventana de la seccion de sistemas de ecuaciones */
   getmaxyx(stdscr, y, x);
   se_win = newwin(y-2, x, 1, 0);
   wbkgd(se_win, COLOR_PAIR(COLOR_FWBBK));
   
   wattron(se_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(se_win, 1, 0, msg_lan->seccion_titles[1]); 
   wattron(se_win, COLOR_PAIR(COLOR_FWBBK));
   do { 
      mvwaddstr(se_win, 3, 0, msg_lan->misc_txt[2]);
      echo();
      wclrtoeol(se_win);
      wgetnstr(se_win, buf, BUFSIZ);
   }while((n = atoi(buf)) <= 0 || n > 11); 
   noecho();
   mvwaddstr(se_win, 5, 0, "X(1)+X(2)+X(3)+...+X(n)=R"); 
   
   /* Configuracion de se_matrix */
   se_matrix.win = se_win;
   se_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
   se_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
   se_matrix.matrix_field_tind_fore = COLOR_PAIR(COLOR_FRBC); 
   se_matrix.matrix_field_tind_back = COLOR_PAIR(COLOR_FRBC);
   se_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
   se_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
   se_matrix.matrix_edit = TRUE;
   se_matrix.matrix_style = "SE"; 
   se_matrix.row = n; /* filas */
   se_matrix.col = n+1; /* columnas de coeficientes + term. ind. */
   se_matrix.field_deep = 5;
   se_matrix.field_space = 1;
   se_matrix.pos_y = 8;
   se_matrix.pos_x = 0;
  
   if(new_matrix_form(&se_matrix) == ERR)
      finish(EXIT_FAILURE);
   
   /* Cargar se_matrix */
   while(1){  
      load_matrix_form(&se_matrix);
      if(sn_wizard_menu(se_win, 11, -1, msg_lan->misc_men[1], NULL,0) == TRUE)
         break;
      redraw_matrix_form(&se_matrix);   
   }    
   
   redraw_matrix_form(&se_matrix);   
   
   if((mA = new_matrix(n, n)) == NULL) /* crear matriz de coef. */
      finish(EXIT_FAILURE);

   if((mb = new_matrix(n, 1)) == NULL) /* crear matriz de t. ind.*/
      finish(EXIT_FAILURE);

   if((mx = new_matrix(n, 1)) == NULL) /* crear matriz de resultados*/
      finish(EXIT_FAILURE);

   matfse2mat(mA, mb, &se_matrix);
   del_matrix_form(&se_matrix);   
   
   if(sysresolv(mA, mb, mx) == M_NOSOL) /* Resolver el sistema */
      ok_wizard_menu(se_win, 11, -1, msg_lan->misc_men[2], 
                     msg_lan->misc_men[7] , A_BLINK); 
   else {   
      /* Configuracion de res_matriz */
      res_matrix.win = se_win;
      res_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
      res_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
      res_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
      res_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
      res_matrix.matrix_edit = FALSE;
      res_matrix.matrix_style = "RESULT"; 
      res_matrix.row = n; /* filas */
      res_matrix.col = 1; /* columnas de resultados */
      res_matrix.field_deep = 11;
      res_matrix.field_space = 1;
      res_matrix.pos_y = 10;
      res_matrix.pos_x = 27;
 
      if(new_matrix_form(&res_matrix) == ERR)
         finish(EXIT_FAILURE);
   
      mat2matf(&res_matrix, mx);

      wattron(se_win, A_BOLD);
      mvwaddstr(se_win, 7, 0, msg_lan->misc_txt[3]); 
      while(1){  
         load_matrix_form(&res_matrix);
         if(sn_wizard_menu(se_win, 12, -1, msg_lan->misc_men[3],NULL,0)
         == TRUE)
            break;
         redraw_matrix_form(&res_matrix);   
      }
      del_matrix_form(&res_matrix);       
   }
   
   del_matrix(mA);     
   del_matrix(mb);     
   del_matrix(mx);     
   
   wclear(se_win);
   wnoutrefresh(se_win);
   doupdate();
   delwin(se_win);
}

/* Seccion para invertir matrices */    
void inv_seccion(void)
{
   WINDOW *inv_win;
   MATRIX_FORM inv_matrix; /* matriz formulario */
   MATRIX *mA;
   double det;
   int n; /* dimencion */
   int x, y;
   
   /* Ventana de la seccion para invertir matrices */
   getmaxyx(stdscr, y, x);
   inv_win = newwin(y-2, x, 1, 0);
   wbkgd(inv_win, COLOR_PAIR(COLOR_FWBBK));
   
   wattron(inv_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(inv_win, 1, 0, msg_lan->seccion_titles[2]); 
   wattron(inv_win, COLOR_PAIR(COLOR_FWBBK));
   do { 
      mvwaddstr(inv_win, 3, 0, msg_lan->misc_txt[0]);
      echo();
      wclrtoeol(inv_win);
      wgetnstr(inv_win, buf, BUFSIZ);
   }while((n = atoi(buf)) <= 0 || n > 12); 
   noecho();
   mvwprintw(inv_win, 5, 0, msg_lan->misc_txt[1], n, n); 
   
   /* Configuracion de inv_matrix */
   inv_matrix.win = inv_win;
   inv_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
   inv_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
   inv_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
   inv_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
   inv_matrix.matrix_edit = TRUE;
   inv_matrix.matrix_style = "NORMAL"; 
   inv_matrix.row = n; /* filas */
   inv_matrix.col = n; /* columnas */
   inv_matrix.field_deep = 5;
   inv_matrix.field_space = 1;
   inv_matrix.pos_y = 8;
   inv_matrix.pos_x = 0;
  
   if(new_matrix_form(&inv_matrix) == ERR)
      finish(EXIT_FAILURE);
   
   /* Cargar inv_matrix */
   while(1){  
      load_matrix_form(&inv_matrix);
      if(sn_wizard_menu(inv_win, 11, -1, msg_lan->misc_men[1],NULL,0) == TRUE)
         break;
      redraw_matrix_form(&inv_matrix);   
   }    
   redraw_matrix_form(&inv_matrix);   
   
   if((mA = new_matrix(n, n)) == NULL) /* crear matriz */
      finish(EXIT_FAILURE);

   matf2mat(mA, &inv_matrix);
   
   if(inv(mA) == M_NOSOL) /* invertir */
      ok_wizard_menu(inv_win, 11, -1, msg_lan->misc_men[2], 
         	     msg_lan->misc_men[8], A_BLINK);    
   else {
      del_matrix_form(&inv_matrix);
      inv_matrix.matrix_edit = FALSE; /* parametro para matriz sin edicion */
      if(new_matrix_form(&inv_matrix) == ERR)
         finish(EXIT_FAILURE);
      mat2matf(&inv_matrix, mA); 
      wattron(inv_win, A_BOLD);
      mvwprintw(inv_win, 5, 0, msg_lan->misc_txt[4],n,n); 
      while(1){  
         load_matrix_form(&inv_matrix);
         if(sn_wizard_menu(inv_win, 11, -1, msg_lan->misc_men[3],NULL,0) 
            == TRUE)
            break;
         redraw_matrix_form(&inv_matrix);   
      }    
   }   
   
   
   del_matrix_form(&inv_matrix);
   del_matrix(mA);
   
   wclear(inv_win);
   wnoutrefresh(inv_win);
   doupdate();
   delwin(inv_win);
}

/* Seccion para reducir matrices */    
void redm_seccion(void) 
{
   WINDOW *redm_win, *ope_win, *ope_winext;
   MATRIX_FORM redm_matrix; /* matriz formulario */
   MATRIX *mA;
   WINBUF *ope_winbuf; /* contendra las operaciones elem. echas a mA*/ 
   char **ope_list; 
   int n, m; /* dimencion */
   int x, y, i;
   
   /* Ventana de la seccion para reducir matrices */
   getmaxyx(stdscr, y, x);
   redm_win = newwin(y-2, x, 1, 0);
   wbkgd(redm_win, COLOR_PAIR(COLOR_FWBBK));

   wattron(redm_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(redm_win, 1, 0, msg_lan->seccion_titles[3]); 
   wattron(redm_win, COLOR_PAIR(COLOR_FWBBK));
   do { 
      mvwaddstr(redm_win, 3, 0, msg_lan->misc_txt[6]);
      echo();
      wclrtoeol(redm_win);
      wgetnstr(redm_win, buf, BUFSIZ);
   }while((n = atoi(buf)) <= 0 || n > 13); 
   
   do { 
      mvwaddstr(redm_win, 4, 0, msg_lan->misc_txt[7]);
      echo();
      wclrtoeol(redm_win);
      wgetnstr(redm_win, buf, BUFSIZ);
   }while((m = atoi(buf)) <= 0 || m > 12); 
   
   noecho();
   mvwprintw(redm_win, 5, 0, msg_lan->misc_txt[1], n, m); 
   
   /* Configuracion de redm_matrix */
   redm_matrix.win = redm_win;
   redm_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
   redm_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
   redm_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
   redm_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
   redm_matrix.matrix_edit = TRUE;
   redm_matrix.matrix_style = "NORMAL"; 
   redm_matrix.row = n; /* filas */
   redm_matrix.col = m; /* columnas */
   redm_matrix.field_deep = 5;
   redm_matrix.field_space = 1;
   redm_matrix.pos_y = 8;
   redm_matrix.pos_x = 0;
  
   if(new_matrix_form(&redm_matrix) == ERR)
      finish(EXIT_FAILURE);
   
   /* Cargar redm_matrix */
   while(1){  
      load_matrix_form(&redm_matrix);
      if(sn_wizard_menu(redm_win, 11, -1,msg_lan->misc_men[1],NULL,0) == TRUE)
         break;
      redraw_matrix_form(&redm_matrix);   
   }    
   
   if((mA = new_matrix(n, m)) == NULL) /* crear matriz */
      finish(EXIT_FAILURE);

   matf2mat(mA, &redm_matrix);
   
   if((ope_list = (char **) calloc(BUFSIZ, sizeof(char *))) == NULL)
      finish(EXIT_FAILURE);
   redmat(mA, ope_list); /* reducir matriz */
 
   del_matrix_form(&redm_matrix);
   redm_matrix.matrix_edit = FALSE; /* parametro para matriz sin edicion */
   if(new_matrix_form(&redm_matrix) == ERR)
      finish(EXIT_FAILURE);
   mat2matf(&redm_matrix, mA); 
   mvwprintw(redm_win, 5, 0, msg_lan->misc_txt[5],n,m); 
   while(1){  
      load_matrix_form(&redm_matrix);
      if(sn_wizard_menu(redm_win, 11, -1, msg_lan->misc_men[12], NULL,0) 
      == TRUE){
         ope_win = subwin(redm_win, y-16, x-2, 14, 1);
         ope_winbuf = new_winbuf(ope_win, BUFSIZ, ope_list);  
         ope_winext = subwin(redm_win, y-8, x, 7, 0);
         wclear(ope_winext);
         box(ope_winext, ACS_VLINE, ACS_HLINE);
         for(i=0; ope_list[i] != NULL; i++);
         mvwprintw(ope_winext, 1, 1, msg_lan->misc_txt[8], i);
         mvwaddstr(ope_winext, 2, 1, msg_lan->misc_txt[9]);
         mvwaddstr(ope_winext, 3, 1, msg_lan->misc_txt[10]);
         mvwaddstr(ope_winext, 4, 1, msg_lan->misc_txt[11]);
         mvwaddstr(ope_winext, 5, 1, msg_lan->misc_txt[12]);
         waddch(ope_winext, ACS_UARROW);
         waddch(ope_winext, ' ');
         waddch(ope_winext, ACS_DARROW);
         waddstr(ope_winext, msg_lan->misc_txt[13]);
         mvwaddch(ope_winext, 6, 0, ACS_LTEE);
         mvwaddch(ope_winext, 6, x-1, ACS_RTEE);
         for(i=1; i < x-1; i++)
            mvwaddch(ope_winext, 6, i, ACS_HLINE);
         touchwin(redm_win);   
         wrefresh(ope_winext);   
         drive_winbuf(ope_winbuf); /* desplazarce por ventana ope_win */
         del_winbuf(ope_winbuf);
         wclear(ope_win);
         wclear(ope_winext);
         delwin(ope_win);
         delwin(ope_winext);
         touchwin(redm_win);
         wrefresh(redm_win);
         redraw_matrix_form(&redm_matrix);   
      }
      redraw_matrix_form(&redm_matrix);      
      if(sn_wizard_menu(redm_win, 11, -1, msg_lan->misc_men[3], NULL,0) 
         == TRUE)
         break;
      redraw_matrix_form(&redm_matrix);   
   }    
   
   del_matrix_form(&redm_matrix);
   del_matrix(mA);

   for(i=0; ope_list[i] != NULL; i++) /* liberar lista de ope. elementales */
      free(ope_list[i]);
   free(ope_list);   
  
   wclear(redm_win);
   wnoutrefresh(redm_win);
   doupdate();
   delwin(redm_win);
}

/* Seccion para reducir manualmente matrices */    
void redm_manual_seccion(void) 
{

   WINDOW *redm_manual_win, *help_win, *help_winext;
   WINBUF *help_winbuf;
   MATRIX_FORM redm_manual_matrix; /* matriz formulario */
   MATRIX *mA;
   FORM *form_ope;
   FIELD *field_ope[5];
   double k;
   int last_field = 3, STOP=FALSE, c_field=0, HELP = FALSE;
   int n, m; /* dimencion */
   int x, y, i, j, ch, opn=0, t;
   char *help_list[37];
   
   /* Ventana de la seccion para reducir matrices */
   getmaxyx(stdscr, y, x);
   redm_manual_win = newwin(y-2, x, 1, 0);
   wbkgd(redm_manual_win, COLOR_PAIR(COLOR_FWBBK));

   wattron(redm_manual_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(redm_manual_win, 1, 0, msg_lan->seccion_titles[4]); 
   wattron(redm_manual_win, COLOR_PAIR(COLOR_FWBBK));
   do { 
      mvwaddstr(redm_manual_win, 3, 0, msg_lan->misc_txt[6]);
      echo();
      wclrtoeol(redm_manual_win);
      wgetnstr(redm_manual_win, buf, BUFSIZ);
   }while((n = atoi(buf)) <= 0 || n > 13); 

   do { 
      mvwaddstr(redm_manual_win, 4, 0, msg_lan->misc_txt[7]);
      echo();
      wclrtoeol(redm_manual_win);
      wgetnstr(redm_manual_win, buf, BUFSIZ);
   }while((m = atoi(buf)) <= 0 || m > 12); 
   
   noecho();
   mvwprintw(redm_manual_win, 5, 0, msg_lan->misc_txt[1], n, m); 
   
   /* Configuracion de redm_manual_matrix */
   redm_manual_matrix.win = redm_manual_win;
   redm_manual_matrix.matrix_field_fore = COLOR_PAIR(COLOR_FWBBE);
   redm_manual_matrix.matrix_field_back = COLOR_PAIR(COLOR_FWBBE);
   redm_manual_matrix.matrix_win_color = COLOR_PAIR(COLOR_FWBBK);
   redm_manual_matrix.matrix_subwin_color = COLOR_PAIR(COLOR_FWBBK);
   redm_manual_matrix.matrix_edit = TRUE;
   redm_manual_matrix.matrix_style = "NORMAL"; 
   redm_manual_matrix.row = n; /* filas */
   redm_manual_matrix.col = m; /* columnas */
   redm_manual_matrix.field_deep = 5;
   redm_manual_matrix.field_space = 1;
   redm_manual_matrix.pos_y = 8;
   redm_manual_matrix.pos_x = 0;
  
   if(new_matrix_form(&redm_manual_matrix) == ERR)
      finish(EXIT_FAILURE);
   
   /* Cargar redm_manual_matrix */
   while(1){  
      load_matrix_form(&redm_manual_matrix);
      if(sn_wizard_menu(redm_manual_win, 11, -1, msg_lan->misc_men[1], NULL,0)
      == TRUE)
         break;
      redraw_matrix_form(&redm_manual_matrix);   
   }    
   
   /* Operaciones elementales efectuadas por el usuario */
   
   if((mA = new_matrix(n, m)) == NULL) /* crear matriz */
      finish(EXIT_FAILURE);
   matf2mat(mA, &redm_manual_matrix);
    
   /* Cadenas de texto para ventana de ayuda */
   help_list[0] = "Efectuar Operaciones Elementales (ayuda)";
   help_list[1] = "";
   help_list[2] = "Funcion 'e':";
   help_list[3] = "Sintaxis: e[tipo](fila i, fila j, escalar k)";
   help_list[4] = "";
   help_list[5] = "Descripcion de argumentos de la funcion:";
   help_list[6] = "Parametro tipo: es un entero comprendido entre 1 y 3 que determina el tipo de";
   help_list[7] = "operacion elemental.";
   help_list[8] = "";
   help_list[9] = "==>SI:";
   help_list[10] = "tipo = 1, significa: Intercambiar fila 'i' por fila 'j', el tercer argumento";
   help_list[11] = "('k') es ignorado.";
   help_list[12] = "tipo = 2, significa: Sumar fila 'j' previamente multiplicada por escalar 'k'";
   help_list[13] = "a fila 'i'.";
   help_list[14] = "tipo = 3, significa: Multiplicar fila 'i' por escalar 'k', segundo argumento";
   help_list[15] = "('j') es ingnorado.";
   help_list[16] = "";
   help_list[17] = "Parametro fila i: es un entero entre 1 y la cantidad de filas de la matriz.";
   help_list[18] = "Parametro fila j: es un entero entre 1 y la cantidad de filas de la matriz.";
   help_list[19] = "Parametro escalar k: Es un numero comprendido en el conjunto de los numeros";
   help_list[20] = "Reales, ej: 2, 4.56, 3/5, -23";
   help_list[21] = "";
   help_list[22] = "Los valores del segundo y tercer argumento no pueden ser iguales, para un";
   help_list[23] = "parametro tipo 1 o 2.";
   help_list[24] = "El cuarto argumento debe ser distinto a cero para un parametro tipo 2 o 3.";
   help_list[25] = "";
   help_list[26] = "==>EJEMPLO:";
   help_list[27] = "e[2](3 ,4, -1/5.7)";
   help_list[28] = "Suma fila '4' previamente multiplicada por '-1/5.7' a la fila '3'.";
   help_list[29] = "";
   help_list[30] = "==>TECLAS:";
   help_list[31] = "F1: Muestra esta ayuda";
   help_list[32] = "m : Navegar por la matriz (q: sale de matriz)";
   help_list[33] = "q : Vuelve al menu principal";
   help_list[34] = "TAB : Navega por los argumentos de la funcion 'e'";
   help_list[35] = "";
   help_list[36] = NULL;
   /* Fin Cadenas de texto para ventana de ayuda */
       
   wclear(redm_manual_win);
   
   del_matrix_form(&redm_manual_matrix);
   redm_manual_matrix.matrix_edit = FALSE;
   redm_manual_matrix.pos_y = 4; /* nueva posicion */
   redm_manual_matrix.pos_x = 0;
   if(new_matrix_form(&redm_manual_matrix) == ERR)
      finish(EXIT_FAILURE);
   mat2matf(&redm_manual_matrix, mA);
   redraw_matrix_form(&redm_manual_matrix);   

   /* Crear formularios  para operacion elemental */
   
   field_ope[0] = new_field(1, 1, 21, 6, 0, 2);
   field_ope[1] = new_field(1, 2, 21, 9, 0, 3);
   field_ope[2] = new_field(1, 2, 21, 12, 0, 3);
   field_ope[3] = new_field(1, 5, 21, 15, 0, 6);
   field_ope[4] = NULL;

   set_field_fore(field_ope[0], A_BOLD);
   set_field_back(field_ope[0], COLOR_PAIR(COLOR_FWBBK));
   set_field_type(field_ope[0], TYPE_INTEGER, 0, 1, 3);
   field_opts_on(field_ope[0], O_AUTOSKIP);

   set_field_fore(field_ope[1], A_BOLD);
   set_field_back(field_ope[1], COLOR_PAIR(COLOR_FWBBK));
   set_field_type(field_ope[1], TYPE_INTEGER, 0, 1, n);
   field_opts_on(field_ope[1], O_AUTOSKIP);

   set_field_fore(field_ope[2], A_BOLD);
   set_field_back(field_ope[2], COLOR_PAIR(COLOR_FWBBK));
   set_field_type(field_ope[2], TYPE_INTEGER, 0, 1, n);
   field_opts_on(field_ope[2], O_AUTOSKIP);
 
   set_field_fore(field_ope[3], A_BOLD);
   set_field_back(field_ope[3], COLOR_PAIR(COLOR_FWBBK));
   set_field_type(field_ope[3], NULL);
   field_opts_on(field_ope[3], O_AUTOSKIP);
   field_opts_off(field_ope[3], O_STATIC);
      
   
   form_ope = new_form(field_ope);
   set_form_win(form_ope, redm_manual_win);
   set_form_sub(form_ope, redm_manual_win);
   post_form(form_ope);
   
   redraw_matrix_form(&redm_manual_matrix);   
   wattron(redm_manual_win, COLOR_PAIR(COLOR_FGBBK));
   mvwaddstr(redm_manual_win, 1, 0, msg_lan->seccion_titles[4]); 
   wattron(redm_manual_win, COLOR_PAIR(COLOR_FWBBK));
   mvwprintw(redm_manual_win, 18, 0, 
             "Funcion de Operacion Elemental - Efectuadas = %d", opn);
   mvwaddstr(redm_manual_win, 19, 0, "Sintaxis: e[tipo](fila i, fila j,");
   waddstr(redm_manual_win," escalar k) - (F1 = ayuda; q = salir)");

   mvwaddstr(redm_manual_win, 21, 0, "F = e[ ](  ,  ,     )");
   wmove(redm_manual_win, 21, 6);
  
   while(STOP == FALSE){   
      set_current_field(form_ope, field_ope[c_field]);
      while(1){ /* ciclo de entrada a formulario de funcion elemental */
         
         wrefresh(redm_manual_win);
         ch = wgetch(redm_manual_win);
      
         if(ch == KEY_LEFT)
            form_driver(form_ope, REQ_LEFT_CHAR);
         else if(ch == KEY_RIGHT)
            form_driver(form_ope, REQ_RIGHT_CHAR);
         else if(ch == KEY_BACKSPACE){
            form_driver(form_ope, REQ_LEFT_CHAR); 
            form_driver(form_ope, REQ_DEL_CHAR);
         }   
         else if(ch == KEY_DC)
            form_driver(form_ope, REQ_DEL_CHAR);
        else if(ch == KEY_HOME)
           form_driver(form_ope, REQ_BEG_FIELD);
        else if(ch == KEY_END)
           form_driver(form_ope, REQ_END_LINE);
        else if(ch == '\t'){  /* mueve al sig. campo */
            form_driver(form_ope, REQ_VALIDATION); /*escribe el bufer*/
            form_driver(form_ope, REQ_NEXT_FIELD);  
         }   
         else if(ch == '\n'){ /* caracter de validacion */
            form_driver(form_ope, REQ_VALIDATION); /*escribe el bufer*/
            if(current_field(form_ope) == field_ope[last_field])
               break; /* formulario completo */
            form_driver(form_ope, REQ_NEXT_FIELD); /*mueve al sig. campo*/
         }   
         else if(ch == 'm'){ /* navegar por matriz */
            load_matrix_form(&redm_manual_matrix);
            wmove(redm_manual_win, 21, 21);
         }   
         else if(ch == 'q'){
            STOP = TRUE;
            break;
         }
         else if(ch == KEY_F(1)){
            HELP = TRUE;
            break;
         }
         else   
            form_driver(form_ope, ch); 
      }

      if(STOP == TRUE){ /* salir */
         del_matrix_form(&redm_manual_matrix);
         del_matrix(mA);
         unpost_form(form_ope);
         free_form(form_ope);
         for(i=0; i < 4; i++)
            free_field(field_ope[i]);
         wclear(redm_manual_win);
         wrefresh(redm_manual_win);
         delwin(redm_manual_win);
         break; /* parar todo */
      }
      
      if(HELP == TRUE){ /* mostrar ayuda */
         if((help_win = subwin(redm_manual_win, 12, x-2, 5, 1)) == NULL)
            finish(EXIT_FAILURE);  
         help_winbuf = new_winbuf(help_win, 37, help_list);
         help_winext = subwin(redm_manual_win, 14, x, 4, 0);  
         box(help_winext, ACS_VLINE, ACS_HLINE); 
         touchwin(redm_manual_win);
         wnoutrefresh(help_win);
         wnoutrefresh(help_winext);
         doupdate();
         drive_winbuf(help_winbuf);
         wclear(help_win);
         wclear(help_winext);
         touchwin(redm_manual_win);
         wnoutrefresh(help_win);
         wnoutrefresh(help_winext);
         doupdate();
         delwin(help_win);
         delwin(help_winext);
         redraw_matrix_form(&redm_manual_matrix); 
         wrefresh(redm_manual_win);
         del_winbuf(help_winbuf);
         HELP = FALSE;
         wmove(redm_manual_win, 21, 21);
         continue;
      }    
            
      t = atoi(field_buffer(field_ope[0], 0));
      i = atoi(field_buffer(field_ope[1], 0));
      j = atoi(field_buffer(field_ope[2], 0));
      if(check_num(field_buffer(field_ope[3], 0)) == OK) /* numero puro */
         k = atof(field_buffer(field_ope[3], 0));
      else if(check_frac(field_buffer(field_ope[3], 0)) == OK){ /* fraccion*/  
         if((k = frac2num(field_buffer(field_ope[3], 0))) == 0){
            wclrtoeol(redm_manual_win);
            mvwaddstr(redm_manual_win, 21, 20, 
            ")  <=== Escalar k Erroneo, Fraccion no valida");      
            c_field=3;
            continue;
         }
      }      
      else { /* error en tipeo de escalar */
         wclrtoeol(redm_manual_win);
         mvwaddstr(redm_manual_win, 21, 20, ")  <=== Escalar k Erroneo");      
         c_field=3;
         continue;
      }   
      
      wclrtoeol(redm_manual_win);
      if(t <= 0 || t > 3){
         wclrtoeol(redm_manual_win);
         mvwprintw(redm_manual_win, 21, 20, 
                   ")  <=== Tipo %d inexistente", t);                  
         c_field=0;          
         continue;          
      }   
      if(i <= 0 || i > n){
         wclrtoeol(redm_manual_win);
         mvwaddstr(redm_manual_win, 21, 20, ")  <=== Fila 'i' Fuera de Rango");      
         c_field=1;
         continue;
      }
      if((j <= 0 || j > n) && t != 3){
         wclrtoeol(redm_manual_win);
         mvwaddstr(redm_manual_win, 21, 20, ")  <=== Fila 'j' Fuera de Rango");      
         c_field=2;
         continue;
      }
      if(i == j && t != 3){
         wclrtoeol(redm_manual_win);
         mvwaddstr(redm_manual_win, 21, 20, ")   <=== Filas Iguales");      
         c_field=1;
         continue;
      }
      if(k == 0 && t != 1){
         wclrtoeol(redm_manual_win);
         mvwaddstr(redm_manual_win, 21, 20, 
            	   ")   <=== Escalar 'k' debe ser distinto a Cero");      
         c_field=3;
         continue;
      }   
            
      switch(t){ /* hacer operacion */
         case 1:
            e1(mA, i-1, j-1);
         break;
         case 2:
            e2(mA, i-1, j-1, k);
         break;   
         case 3:
            e3(mA, i-1, k);
         break;   
      }

      ++opn;
      mvwprintw(redm_manual_win, 18, 0, 
         	"Funcion de Operacion Elemental - Efectuadas = %d", opn);
      mat2matf(&redm_manual_matrix, mA);
      redraw_matrix_form(&redm_manual_matrix); 

      /*limpiar buffer's*/
      set_field_buffer(field_ope[0], 0, " ");  
      set_field_buffer(field_ope[1], 0, " ");     
      set_field_buffer(field_ope[2], 0, " ");     
      set_field_buffer(field_ope[3], 0, " ");     
      c_field=0;

      mvwaddstr(redm_manual_win, 21, 0, "F = e[ ](  ,  ,     )");
   }   
}

/* Seccion de ayuda y comentarios del programa */
void help_seccion(void)
{
   WINDOW *help_seccion_winext, *help_seccion_win; 
   WINBUF *help_seccion_winbuf;
   int x, y;
   char *help_list[32];
 
   help_list[0] = "SECCION DE AYUDA DE MCEITOR";
   help_list[1] = "";
   help_list[2] = "TECLAS:";      
   help_list[3] = "";
   help_list[4] = "Ctrl+C : Aborta el programa en toda instancia.";      
   help_list[5] = "En ventanas con texto (como la actual) puede desplazarce con las flechas";
   help_list[6] = "Arriba-Abajo, Page Up y Page Down. Otra tecla sale de la ventana."; 
   help_list[7] = "Las teclas validas en matrices son:";
   help_list[8] = "q: Sale de la matriz.";
   help_list[9] = "h: Se posiciona el cursor en la primera columna y fila de la matriz.";
   help_list[10] = "e: Se posisiona el cursor en la ultima columna y fila de la matriz.";
   help_list[11] = "TAB: Posiciona el cursor en el siguiente elemento de la matriz.";
   help_list[12] = "Home: Mueve el cursor al principio de linea del elemento de la matriz.";
   help_list[13] = "End: Mueve el cursor al fin de linea del elemento de la matriz.";
   help_list[14] = "Flechas Izq. y Derecha: Desplazan el cursor dentro del elemento de la matriz.";
   help_list[15] = "Delete y BackSpace: Borran caracteres de un elemento de la matriz.";
   help_list[16] = "";
   help_list[17] = "BUGS (FALLOS DEL PROGRAMA)";
   help_list[18] = "";
   help_list[19] = "Algunos errores de calculo se presentan cuando se trabaja con numeros";
   help_list[20] = "peque#os producidos por calculos internos del programa afectando el resultado";
   help_list[21] = "final. ";
   help_list[22] = "La variable MIN_NUMP dentro de mceitor.c controla con que precision minima";
   help_list[23] = "se permite trabajar (un numero menor a MIN_NUMP se redondea a cero), cambie";
   help_list[24] = "el valor por alguno mas peque#o en caso de resultados erroneos.";
   help_list[25] = "";
   help_list[26] = "El cambio de idioma no esta completado, se necesita un traductor."; 
   help_list[27] = "";   
   help_list[28] = "Otro error? envieme la descripcion del problema a mi casilla de e-mail.";
   help_list[29] = "Ver 'Acerca de mceitor' en menu principal, para contactarme, gracias."; 
   help_list[30] = "";      
   help_list[31] = NULL;      
  
   getmaxyx(stdscr, y, x);

   help_seccion_winext = newwin(y-2, x, 1, 0);
   help_seccion_win = subwin(help_seccion_winext, y-4, x-2, 2, 1);
   help_seccion_winbuf = new_winbuf(help_seccion_win, 32, help_list);
   box(help_seccion_winext, ACS_VLINE, ACS_HLINE); 
   touchwin(help_seccion_winext);
   wnoutrefresh(help_seccion_win);
   wnoutrefresh(help_seccion_winext);
   doupdate();
   drive_winbuf(help_seccion_winbuf);
   wclear(help_seccion_win);
   wclear(help_seccion_winext);
   touchwin(help_seccion_winext);
   wnoutrefresh(help_seccion_win);
   wnoutrefresh(help_seccion_winext);
   doupdate();
   delwin(help_seccion_win);
   delwin(help_seccion_winext);
   del_winbuf(help_seccion_winbuf);
 
   touchwin(stdscr);
   refresh();
}


/* Seccion acerca del programa y autor de mceitor */
void mceitor_seccion(void)   
{
   WINDOW *mc_win;
   int x, y;
   
   getmaxyx(stdscr, y, x);
   
   /* Ventana del autor */
   mc_win = newwin(20, 50, 2, x/2 - 25);
   wclear(mc_win);
   wbkgd(mc_win, COLOR_PAIR(COLOR_FWBBK));
   
   wattron(mc_win, COLOR_PAIR(COLOR_FRBBK));
   box(mc_win, ACS_VLINE, ACS_HLINE);
   wattron(mc_win, COLOR_PAIR(COLOR_FCBBK));  
   mvwprintw(mc_win, 1, 2, "%s", MC_VERSION);
   wattron(mc_win, COLOR_PAIR(COLOR_FWBBK));  
   mvwprintw(mc_win, 3, 2, "Programa de manejo algebraico de matrices");
   mvwprintw(mc_win, 4, 2, "escrito con la libreria ncurses bajo C");
   mvwprintw(mc_win, 5, 2, "para Unix's.");
   mvwprintw(mc_win, 7, 2, "Autor    : ");
   wattron(mc_win, COLOR_PAIR(COLOR_FCBBK));  
   wprintw(mc_win, "Boris Estudiez");
   wattron(mc_win, COLOR_PAIR(COLOR_FWBBK));  
   mvwprintw(mc_win, 8, 2, "Mail(1)  : 43824@electronica.frc.utn.edu.ar");
   mvwprintw(mc_win, 9, 2, "Mail(2)  : boris@flashmail.com");
   mvwprintw(mc_win, 11, 2, "ICQ      : 45745799");
   mvwprintw(mc_win, 12, 2, "Nick     : slice");
   mvwprintw(mc_win, 13, 2, "Fecha    : 03/03/2002");
   mvwprintw(mc_win, 14, 2, "Licencia : GNU");
   mvwprintw(mc_win, 16, 2, "Visite -->");
   wattron(mc_win, COLOR_PAIR(COLOR_FGBBK));  
   wprintw(mc_win, " http://geocities.com/slicesoft");
   wattron(mc_win, COLOR_PAIR(COLOR_FWBBK));  
   mvwprintw(mc_win, 17, 2, "C-Devel, textos, electronica, unix's y mas...");

   wrefresh(mc_win);
   wgetch(mc_win);
   
   delwin(mc_win);
   touchwin(stdscr);
   refresh();
   
}      

/*----------------------FUNCIONES AUXILIARES-----------------------------*/

void finish(int n)
{
   clear();
   refresh();
   endwin(); /* Restaurar terminal */
   switch(n){
      case EXIT_FAILURE:
         /* perror("Descripcion"); error definido por la implantacion */
         fprintf(stderr, "Mceitor a efectuado un error...\n");
         fprintf(stderr, "Si persiste el error envie su descripcion a:\n");
         fprintf(stderr, "43824@electronica.frc.utn.edu.ar - boris@flashmail.com\n\n");
         break;
      case EXIT_TERM_ERR:
         fprintf(stderr, "\nMceitor: error, el terminal debe tener al menos");
         fprintf(stderr, " una dimencion de 80x24 caracteres.\n\n");
         break;
   }       
   exit(n);
}

     
/****************************************************************************
 * check_frac: comprueba si la cadena frac es una fraccion (x/x o x.x/x.x).	    *
 * I: char *frac  O: ERR o OK						    *
 ****************************************************************************/
int check_frac(char *frac)
{
   while(isspace(*frac))
      ++frac;
   if(*frac == '-')   
      ++frac;   
   while(isdigit(*frac))
      ++frac;
   if(*frac == '/')   
      ++frac;
   while(isdigit(*frac))
      ++frac;   
   if(*frac == '.') 
      ++frac;
   while(isdigit(*frac))
      ++frac;   
   while(isspace(*frac))
      ++frac;
   if(*frac != '\0')
      return ERR;
   else
      return OK;   
}
      
/****************************************************************************
 * check_num: comprueba si la cadena num es un numero puro. (xxx o x.xx)    *
 * I: char *num  O: ERR o OK					    	    *	
 ****************************************************************************/
int check_num(char *num)
{
   while(isspace(*num))
      ++num;
   if(*num == '-')
      ++num;
   while(isdigit(*num))
      ++num;
   if(*num == '.')
      ++num;
   while(isdigit(*num))
      ++num;
   while(isspace(*num))
      ++num;
   
   if(*num != '\0')
      return ERR;
   else
      return OK;
}   

/****************************************************************************
 *frac2num: Convierte una fraccion a numero de una cadena, usar antes	    *
 *check_frac().								    *
 ****************************************************************************/
double frac2num(char *frac)
{
   int i, sign = 1;
   char num_str[1000], den_str[1000];
   
   memset(num_str, 0, 1000);
   memset(den_str, 0, 1000);
   
   while(isspace(*frac))
      ++frac;
   if(*frac == '-')   
      ++frac, sign = -1;   
   for(i=0; isdigit(*frac); i++)
      num_str[i] = *frac++;
   if(*frac == '/')
      ++frac;
   for(i=0; isdigit(*frac); i++)
      den_str[i] = *frac++;
   if(atof(den_str) == 0)
      return 0; /* error */
   return (double) (sign * (atof(num_str)/atof(den_str)));
}    
      
      
