/************************************************************************ 
 * Matriceitor 0.8              					*
 *  									*
 * Autor : Boris Estudiez 						*
 * Nick  : xdarth							*
 * Fecha : 12/07/2001							*
 * Mails : boris@flashmail.com - 43924@electronica.frc.utn.edu.ar 	*
 *	 								*
 * Licenced Under GNU							*
 *	 								*
 * Requiere : Libreria Matematica (libm) , man math			*
 *	 								*
 * Compilacion Bajo Unix's: make					*
 * Desde gcc: gcc mceitor.c mxlib.c -lm -o mceitor      		*
 * Ejecucion: ./mceitor 						*
 *	 								*
 * Compilacion Bajo Windows/MS-DOS					*
 * Ignorar Warnings. 							*
 * Recomiendo Usar Compiladores GNU como Dev-C++ y DJGPP   		*
 * este ultimo tiene la misma sintaxis que el gcc de unix.		*
 *  									*
 *	 								*
 * Powered by ANSIC!							*
 *	 								*
 ************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "include/mxlib.h"

/*Funciones de menues*/
void detmenu(void);
void sismenu(void);
void invmenu(void);
void redmenu(void);

/* Funciones auxiliares */
void clr(void);

/*Variables Globales*/
static char buf[BUFSIZ]; /* bufer */
static char error[50]; /* mensage de error */

int main(void)
{	
 
   setvbuf(stdin, NULL, _IONBF, 0);
   setvbuf(stdout, NULL, _IONBF, 0);
    
   while(1){
      clr();
      printf("\t\t\t\tMatriceitor 0.8\n");
      printf("\t    Por Boris Estudiez - 43824@electronica.frc.utn.edu.ar\n\n");
   
      printf("Elija una opcion:\n");
      printf("1) Calcular determinates\n");
      printf("2) Sistemas de ecuaciones lineales\n");
      printf("3) Invertir matriz\n");
      printf("4) Reducir matriz por filas\n");
      printf("Q) Salir\n\n");
      printf("%s", (error[0])? error: " ");  
      printf("\nopcion: ");
   
      memset(error, 0, 50);
      memset(buf, 0, BUFSIZ);
      fgets(buf, BUFSIZ, stdin);
           
      switch(buf[0]){
         case '1':
            detmenu();
            break;
         case '2':
            sismenu();
            break;
         case '3':
            invmenu();
            break;
         case '4':
            redmenu();
            break;
         case 'q': case 'Q':
            printf("Adios...\n");
            exit(0);
            break;
         default:
            strcpy(error, "Error: Opcion incorrecta!\n");
            break;
      }      
   }   
}   
      

void detmenu(void)
{
   MATRIX mat; 
   int c, f;
   
   clr(); 
   printf("\t\tCalculo de Determinates de Matrices de orden (nxn)\n");
   printf("\tMetodo: Triangular matriz, y calcular det. aplicando "); 
   printf("propiedades.\n\n");
   
   do {
      printf("Dimencion (mayor a 0): ");
      fgets(buf, BUFSIZ, stdin);
      c = f = atoi(buf);
   }while(c <= 0);

   if(creatmat(&mat, f, c) == NO_MEMORY){
      fprintf(stderr, "\nNo hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }
   
   printf("\nIngrese los valores de la matriz de %dx%d\n", f, c);
   loadmat(&mat, "mat");
   printf("\nLa matriz contiene los siguientes valores:\n\n");
   printmat(&mat);      
   printf("\nDeterminante = %g\n", det(&mat));
   printf("\n(Enter para volver al menu principal)\n\n");
   fgets(buf, BUFSIZ, stdin);
   memset(buf, 0, BUFSIZ);
   freemat(&mat);
   
}      
      

void sismenu(void)
{
   MATRIX A, b, x;
   int f, c, i;
   
   clr();
   printf("\tSistema de Ecuaciones Lineales de n Incognitas y n Ecuaciones\n\n");
   printf("Ax = b\n");
   printf("Donde A: matriz de coeficientes principales de las incognitas.\n");
   printf("      b: matriz de resultados.\n");
   printf("Metodo : Cramer ( Xk = det(Ak)/det(A) )\n\n");
   
   do {
      printf("Numero de incognitas (mayor a 0): ");
      fgets(buf, BUFSIZ, stdin);
      f = c = atoi(buf);
   }while(c <= 0);   
   
   if(creatmat(&A, f, c) == NO_MEMORY){ /* matriz de coeficientes */
      fprintf(stderr, "\nNo hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }   
   
   if(creatmat(&b, f, 1) == NO_MEMORY){ /* matriz de resultados */
      fprintf(stderr, "\nNo hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }
   
   if(creatmat(&x, f, 1) == NO_MEMORY){ /* matriz con los valores de solucion */
      printf("No hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }
   
   printf("\nValores para la matriz de coef. A de %dx%d:\n\n", f, c);
   loadmat(&A, "A");
   printf("\nValores para la matriz de resultados b de %dx%d:\n\n", f, 1);
   loadmat(&b, "b");
   if(sysresolv(&A, &b, &x) == NO_SOL)
      printf("\n\nEl sistema no tiene solucion.\n\n");
   else {
      printf("\n\nSistema Compatible determinado, valores de las %d incognitas:\n", x.fil);
      for(i = 0; i < x.fil; i++)
         printf("x%d = %g\n", i+1, *dmat(&x, i, 0));
   }      
   printf("\n\n(Enter para volver al menu principal)\n\n");
   fgets(buf, BUFSIZ, stdin);
   memset(buf, 0, BUFSIZ);
   freemat(&A);
   freemat(&b);
   freemat(&x);
}   

void invmenu(void)
{
   MATRIX A;
   int c, f;
   
   clr();
   printf("\t\t\t  Invertir Matriz (nxn)\n");
   printf("\t  La invercion se hace a partir de: inv(A) = adj(A)/det(A)\n\n");
   
   do{
      printf("Dimencion de la Matriz A (mayor a 0): ");
      fgets(buf, BUFSIZ, stdin);
      f = c = atoi(buf);
   }while(c <= 0);   
   
   if(creatmat(&A, f, c) == NO_MEMORY){ /* matriz */
      fprintf(stderr, "No hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }
   
   printf("Valores para la matriz A(%dx%d): \n", f, c);
   loadmat(&A, "A");
   printf("La matriz A contiene:\n\n");
   printmat(&A);
   
   if(inv(&A) == NO_SOL)
      printf("\n\nA no es una matriz invertible!\n");
   else {
      printf("\nLa matriz inverza de A(%dx%d):\n\n", f, c);
      printmat(&A);
   }  
   
    
   printf("\n(Enter para volver al menu principal)\n\n");   
   fgets(buf, BUFSIZ, stdin);
   memset(buf, 0, BUFSIZ);
   freemat(&A);
}      


void redmenu(void)
{
  
   MATRIX A;
   int c, f;
   
   clr();
   printf("\t\t  Reducir Por Filas a la matriz A(nxm)\n");
   printf("\t\t\t   (n > 0 y m > 0)\n\n");
   
   printf("Dimenciones de la Matriz A\n");
   do{
      printf("Filas: ");
      fgets(buf, BUFSIZ, stdin);
      f = atoi(buf);
   }while(f <= 0);
      
   
   do{
      printf("Columnas: ");
      fgets(buf, BUFSIZ, stdin);
      c = atoi(buf);
   }while(c <=0);   
   
   if(creatmat(&A, f, c) == NO_MEMORY){ /*matriz */
      fprintf(stderr, "No hay memoria disponible!\n");
      exit(EXIT_FAILURE);
   }
   
   printf("\nValores para la matriz A(%dx%d): \n\n", f, c);
   loadmat(&A, "A");
   redmat(&A);
   printf("\nMatriz A(%dx%d): \n\n", f, c);
   printmat(&A);
   printf("\nSu reducida por filas es:\n\n");
   printmat(&A);
   
   printf("\n(Enter para volver al menu principal)\n\n");   
   fgets(buf, BUFSIZ, stdin);
   memset(buf, 0, BUFSIZ);
   freemat(&A);
}   

/*----------------------FUNCIONES AUXILIARES-----------------------------*/


/*clr: Limpia la pantalla, probado en : FreeBSD, Linux */
void clr(void)
{
    printf("\033c"); /* No vamos a usar NCURSES para esto :) */
}   

